/* GCC */

#include <iostream>

#include <cstdio>

#include <vector>

#include <math.h>

using namespace std;

vector < vector < int > > gr;

vector < bool > used;

int c;

void DFS(int x){

    used[x]=true;

    c++;

    for(int k=0; k<gr[x].size(); k++) if(!used[gr[x][k]]) DFS(gr[x][k]);

}

int main(){

    freopen("crossing.in", "r", stdin);

    freopen("crossing.out", "w", stdout);

    int a,b;

    while(cin >> a >> b){

        if(max(a,b)>gr.size()) gr.resize(max(a,b));

        a--; b--;

        gr[a].push_back(b);

        gr[b].push_back(a);

    }

    int n=gr.size();

    vector < int > res;

    used.resize(n, false);

    for(int i=0; i<n; i++){

        for(int j=0; j<n; j++) used[j]=false;

        used[i]=true;

        a=0; c=0;

        if(i==0)a=1;

        DFS(a);

        if(c!=n-1) res.push_back(i);

    }

    printf("%d", res[0]+1);

    for(int i=1; i<res.size(); i++){

        printf(" %d", res[i]+1);

    }

    cout << endl;

}
