/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, i, a, b, t;
vector <int> otv, tin, fup;
vector < vector <int> > v;
bool flag[1234570], used[1234570];

void dfs(int cur, int p)
{
    int children = 0;
    fup[cur] = tin[cur] = t++;
    flag[cur] = true;
    for(int i = 0; i < v[cur].size(); i++)
    {
        int to = v[cur][i];
        if(to == p)
            continue;
        if(flag[to] == true)
            fup[cur] = min(fup[cur], tin[to]);
        else
        {
            children++;
            dfs(to, cur);
            fup[cur] = min(fup[cur], fup[to]);
            if(p != -1 && tin[cur] <= fup[to] && used[cur] == false)
            {
                otv.push_back(cur + 1);
                used[cur] = true;
            }
        }
    }
    if(p == -1 && children > 1)
        otv.push_back(cur + 1);
}

int main()
{
    freopen("crossing.in", "r", stdin);
    freopen("crossing.out", "w", stdout);

    n = 0;
    while(scanf("%d %d", &a, &b) == 2)
    {
        for(i = n; i < max(a, b); i++)
            v.push_back(vector <int> ());
        n = v.size();

        a--;
        b--;
        v[a].push_back(b);
        v[b].push_back(a);
    }
    tin.resize(n);
    fup.resize(n);
    otv.clear();
    fill(flag, flag + n, false);
    fill(used, used + n, false);

    t = 0;
    dfs(0, -1);

    sort(otv.begin(), otv.end());

    for(i = 0; i + 1 < otv.size(); i++)
        printf("%d ", otv[i]);
    printf("%d\n", otv[i]);

    return 0;
}







