/* GCC */

#include <fstream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

size_t n, a[100][100], l, m(0xffffffff), s, d[100][100], d_last[100];
bool b[100], first;

size_t get_sum(size_t j)
{
    size_t ret(0);
    for(size_t i = 0; i < n-j; ++i)
        ret += a[i][j];
    return ret;
}

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("election.in");
    in >> n;
    for(size_t i = 0; i < n; ++i)
    {
        l = (i == 0 ? n-1 : n-i);
        for(size_t j = 0; j < l; ++j)
            in >> a[i][j];
    }
    in.close();
    a[0][n-1] = a[0][n-2] + a[1][n-2];
    for(size_t i = 0; i < n; ++i)
        for(size_t j = n-i-2; j != 0xffffffff; --j)
            a[i][j] = min(a[i][j], a[i][j+1]);
    for(size_t j = 0; j < n; ++j)
        m = min(m, get_sum(j));
    for(size_t j = 0; j < n; ++j)
    {
        s = get_sum(j);
        for(size_t i = 0; s != m; ++i)
        {
            l = min(s-m, a[i][j] - (j == 0 ? 0 : a[i][j-1]));
            a[i][j] -= l, s -= l;
        }
    }
    l = 0;
    for(size_t i = 0; i < n; ++i)
        for(size_t k = 0; k < a[i][0]; ++k)
        {
            d[l][0] = i;
            d_last[l++] = 0;
        }
    for(size_t j = 1; j < n; ++j)
    {
        l = 0;
        for(size_t i = 0; i < n-j; ++i)
            for(size_t k = 0; k < a[i][j]-a[i][j-1]; ++k)
            {
                while(d[l][d_last[l]] != n-j)
                    ++l;
                d[l][++d_last[l]] = i;
                ++l;
            }
    }
    ofstream out("election.out");
    out << m << '\n';
    for(l = 0; l < m; ++l)
    {
        first = true;
        for(size_t i = 0; i < n; ++i)
            b[i] = false;
        for(size_t i = 0; i <= d_last[l]; ++i)
        {
            b[d[l][i]] = true;
            first ? (out << d[l][i]+1) : (out << ' ' << d[l][i]+1);
            first = false;
        }
        for(size_t i = 0; i < n; ++i)
            if(!b[i])
            {
                first ? (out << i+1) : (out << ' ' << i+1);
                first = false;
            }
        out << '\n';
    }
    out.close();
    return 0;
}
