/* GCC */

#include <fstream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("race.in");
    int n, t1, t2, a, b, cur(0), cur_cnt;
    in >> n >> t1 >> t2 >> a >> b;
    vector<int> p(n), q(n);
    for(int i = 0; i < n; ++i)
        in >> p[i];
    if(a < b)
    {
        swap(a, b);
        swap(t1, t2);
        reverse(p.begin(), p.end());
    }
    in.close();
    adjacent_difference(p.begin(), p.end(), q.begin());
    unsigned long long ans(0);
    for(int i = 0; i < n; ++i)
    {
        cur += q[i];
        if(cur > 0)
        {
            cur_cnt = (cur+a-1)/a;
            q[i] -= cur_cnt*a, cur -= cur_cnt*a;
            if(i + t1 < n)
                q[i + t1] -= cur_cnt*(b-a);
            if(i + t1 + t2 < n)
                q[i + t1 + t2] += cur_cnt*b;
            ans += cur_cnt;
        }
    }
    ofstream out("race.out");
    out << ans << '\n';
    out.close();
    return 0;
}
